@echo off
setlocal
set D2STITLE=Video Reader for Any2D2 v1.0
title %D2STITLE%
echo %D2STITLE%

:: Uncomment the following lines to adjust encoding quality
:: set MP3=-aq
:: set QUALITY=-1

if exist %1 goto allok
echo Syntax: %~nx0 ^<input^> [output-base-name]
goto :EOF
:allok

setlocal
if exist mplayer set MPLAYEREX=1
mplayer.exe -really-quiet -identify -frames 0 -vo null %1 >d2_smart.tmp
if not errorlevel 1 goto allok2
del d2_smart.tmp
echo mplayer.exe not found, running d2.bat with default settings
d2.bat %MP3% %QUALITY% %1 %2
goto :EOF
:allok2
if not defined MPLAYEREX rd /s /q mplayer

for /F "tokens=1,2 delims==" %%i in (d2_smart.tmp) do set %%i=%%j
del d2_smart.tmp
if defined ID_VIDEO_WIDTH goto allok3
echo %1 is not a video file!
goto :EOF
:allok3

set /a MPLAYER_ASPECT=(5+100*%ID_VIDEO_WIDTH%/%ID_VIDEO_HEIGHT%)/10
if %MPLAYER_ASPECT% geq 19 set ASPECT=-16
if %MPLAYER_ASPECT% geq 20 set ASPECT=-2.
if %MPLAYER_ASPECT% geq 22 set ASPECT=-2
if %MPLAYER_ASPECT% leq 17 set ASPECT=-15
if %MPLAYER_ASPECT% leq 15 set ASPECT=-4

if /i "%ID_VIDEO_CODEC%" equ "ffflv" set ID_AUDIO_FORMAT=
if /i "%ID_VIDEO_CODEC%" equ "ffvp6f" set ID_AUDIO_FORMAT=
if /i "%ID_AUDIO_FORMAT%" equ "85" (set AUDIO=-ac) else set AUDIO=%MP3%

if defined ID_FILE_SUB_FILENAME set FILESUBS="%ID_FILE_SUB_FILENAME%"
if defined ID_SID_0_LANG set SUBS=-s0
if defined ID_SID_1_LANG set SUBS=-s1

d2.bat %ASPECT% %AUDIO% %QUALITY% %SUBS% %1 %FILESUBS% %2